var idEstudio;

$(document).ready(
	function() {
		inicial();
	}
);

function inicial(){
	limpiarTabla();
	realizaConsulta();
	inicializarBotones();
	$("table thead tr").addClass("encabezado");
}

function limpiarTabla(){	
	$('#divTablaIn').remove();
	var div = '<div id="divTablaIn"></div>';
	$('#divTablaExt').append(div);
	var tabla = $("<table class='table table-striped'/>").attr('id',"cataEstudio");       
	$("#divTablaIn").append(tabla);	
}

function realizaConsulta(){				
	// Obtener numero de menu
	var menu        = $("#pmn").val();
	var menuRegreso = $("#pmnReturn").val();
	var namespace = "/catalogos/categorias/";
    var rowId=null;
    var oTable=null;
     oTable=$('#cataEstudio').dataTable({		    
	   "bAutoWidth": false,
		"oLanguage":{	"sProcessing":     "Procesando...",
						"sLengthMenu":     "Mostrar _MENU_ registros",
						"sZeroRecords":    "Sin eventos encontrados",
						"sEmptyTable":     "Sin eventos encontrados",
						"sInfo":           "Mostrando  _START_ al _END_ de  _TOTAL_ ",
						"sInfoEmpty":      "0 registros",
						"sInfoFiltered":   "(filtrado de un total de _MAX_ registros)",
						"sSearch":         "Buscar:",
						"sInfoThousands":  ",",
						"sLoadingRecords": "Cargando...",
						"oPaginate": {
							"sFirst":    "Primero",
				        	"sLast":     "&Uacute;ltimo",
				        	"sNext":     "Siguiente",
				        	"sPrevious": "Anterior"
				    	}
				},
		"iDisplayLength": 10,
		"bInfo"     : false,
		"bFilter"   : true,
		"bSort"     : false,
		"bPaginate" :true,
		"sPaginationType" : "full_numbers",
		"aaSorting": [],
		"sAjaxSource": "listadoCategorias",
		"sAjaxDataProp":"", 
	    "aoColumns": [
						{"sTitle":"Nombre", 				"mDataProp":"nombre",		"bSearchable": true, sWidth : "100px"},
						{"sTitle":"Accion",					"mDataProp":"nombre",		"bSearchable": true, sWidth : "30px"}
	          			],
	    		        'fnRowCallback': function(nRow, aData, iDisplayIndex, iDisplayIndexFull) {
	    		        
	    		        	var link = '<a onClick="actualizaCategorias('+aData["idCategoria"]+')" data-toggle="modal" data-target="#modalAgregaActualiza"> ' + aData["nombre"] +'</a>';
	    		        	var button = '<button class="btn btn-danger" type="button" onclick="eliminar(' + aData["idCategoria"] + ')">Eliminar</button> ';
	    		        	$(nRow).attr("id",aData["idCategoria"]);
	    		        	$('td:eq(0)', nRow).html(link);
	    		        	$('td:eq(1)', nRow).html(button);
		          			
	   		       		}
		});
     
}

function validarAgregar(){
	
	$("#forma").validate(
		      {
		        rules: 
		        {
		        	nombreEstudio: 
		          {
		            required: true,
		            maxlength: 50,
		            regex:"^[a-zA-Z0-9 ]+$"
		          }
		        },
		        messages: 
		        {
		        	nombreEstudio: 
		          {
		            required: "Nombre del Estudio es obligatorio.",
		            maxlength: "Nombre no debe exceder 50 caracteres",
		            regex: "Nombre debe ser con caracteres alfanumericos"
		          }
		        }
	});
	
	$.validator.addMethod("regex",function(value,element,regexp){
	      var re= new RegExp(regexp);
	      return this.optional(element) || re.test(value);
	},"Only Characters from A-z");
}

function eliminar(id){
	if(confirm('¿Esta seguro de borrar este registro?')){
		var jsonString = '{"idCategoria" : "' + id + '"}';
		var stringJson = JSON.parse(jsonString);
		callActionAjax("/catalogos/categorias/eliminaCategoria", stringJson, procesaRespuestaActualiza);
	}
}

function inicializarBotones(){
	$("#nuevo").click(function()  
	{		
		window.location.href = contextPath + "/catalogos/categorias/dirigirAgregarCategoria.action?pmn=212&pmnReturn=212";				
	});
}

function regreso(){	
	var menu = $("#pmn").val();
	if(menu == '' || menu == null || menu == undefined)
		menu = 212;
	window.location.href = contextPath + "/catalogos/categorias/index.action?pmn=" + menu;
}

function actualizaCategorias(idCategori) {	
	$('#inpCategoria').val('');
	idCategoria = idCategori;
	llamaObtenCategorias(idCategoria);
}

function llamaObtenCategorias(idCategoria) {
	var jsonString = '{"idCategoria" : "'+ idCategoria +'"}';
	var stringJson = JSON.parse(jsonString);
	callActionAjax( "/catalogos/categorias/llamaObtenCategorias", stringJson, procesaRespuestaObtenCategoria);
}

function procesaRespuestaObtenCategoria(jsonData) {
	//console.info(JSON.stringify(jsonData));
	var est = jsonData.categoria;
	//debugger
	$('#inpCategoria').val(est.nombre);
}

function llamaActualizaCategoria() {
	var nombre = $('#inpCategoria').val();
	var jsonString = '{"idCategoria" : "'+ idCategoria + '", "nombreCategoria" : "' + nombre  +'"}';	
	console.log(jsonString);
	var stringJson = JSON.parse(jsonString);
	callActionAjax( "/catalogos/categorias/llamaActualizaCategoria", stringJson, procesaRespuestaActualiza);

}

function procesaRespuestaActualiza(jsonData) {
	
	var seRepite = jsonData.seRepiteSigla;
	
	$('#modalAgregaActualiza').modal('hide');
	
	if(!seRepite) {
		showMessage("Actualizado con exito");
	}else {
		showError("La sigla se repite en otro Estudio.");
	}
	
	inicial();	
}

function callActionAjax(actionRoute, jsonActionParameter, functionProcessor){
	console.log(actionRoute);
	 $.ajax({
	     url: contextPath + actionRoute,
	     type: 'POST',
	     data:  jsonActionParameter, 
		 dataType: "json",
	     success:function(response){ 
	    	 functionProcessor(response);    
	     },
	     error:function(jqXhr, textStatus, errorThrown){
	         console.error("Error: " + textStatus + " ::: " + errorThrown + " ::: " + jqXhr);
	         showError("Problemas al enviar los datos.");
	     }
	 });	
}